/*
 * arch/arm/mach-ambarella/codec-tlv320aic326x.c
 *
 * Author: Eric Chen <pzchen@ambarella.com>
 *
 * History:
 *	2012/05/11 - [Eric Chen] Created file
 *
 * Copyright (C) 2004-2010, Ambarella, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <linux/platform_device.h>
#include <linux/i2c.h>
#include <linux/gpio.h>

static struct i2c_board_info ambarella_tlv320aic326x_board_info = {
	I2C_BOARD_INFO("aic326x", 0x18),
};

int ambarella_init_tlv320aic326x(u8 i2c_bus_num, u8 i2c_addr)
{
	if (i2c_addr)
		ambarella_tlv320aic326x_board_info.addr = i2c_addr;

	i2c_register_board_info(i2c_bus_num, &ambarella_tlv320aic326x_board_info, 1);
	return 0;
}
